## lager 0.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
cmake_policy(SET CMP0048 NEW) # enable project VERSION
cmake_policy(SET CMP0056 NEW) # honor link flags in try_compile()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

project(lager VERSION 0.1.0)

if(MSVC)
  set(CMAKE_CXX_STANDARD 20)
  add_compile_options(/Wall /Zc:preprocessor /bigobj)
else()
  set(CMAKE_CXX_STANDARD 20)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS on)
set(CMAKE_CXX_EXTENSIONS off)
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
endif()

option(lager_BUILD_TESTS "Build tests" ON)
option(lager_BUILD_FAILURE_TESTS "Build failure tests" ON)
option(lager_BUILD_EXAMPLES "Build examples" ON)
option(lager_BUILD_DEBUGGER_EXAMPLES "Build examples that showcase the web based debugger" ON)
option(lager_BUILD_DOCS "Build docs" ON)
option(lager_EMBED_RESOURCES_PATH "Embed installation paths for easier, non-portable resource location" ON)
option(lager_DISABLE_STORE_DEPENDENCY_CHECKS "Disable compile-time checks for store dependencies" OFF)

if (NOT lager_EMBED_RESOURCES_PATH AND lager_BUILD_EXAMPLES)
  message(FATAL_ERROR "Examples require embedded resources path")
endif()

if (MSVC AND NOT lager_DISABLE_STORE_DEPENDENCY_CHECKS)
  message(WARNING "compile-time checks for store dependencies are currently not supported with msvc")
  set(lager_DISABLE_STORE_DEPENDENCY_CHECKS ON)
endif()

if (NOT lager_BUILD_EXAMPLES AND lager_BUILD_DEBUGGER_EXAMPLES)
    message(WARNING "examples using the web-based debugger are disabled when examples are disabled")
    set(lager_BUILD_DEBUGGER_EXAMPLES OFF)
endif()

find_program(CCACHE ccache)
if (CCACHE)
  message(STATUS "Using ccache: ${CCACHE}")
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE})
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE})
else()
  message(STATUS "Could not find ccache")
endif()

#  Targets
#  =======

# the library
add_library(lager INTERFACE)
target_include_directories(lager INTERFACE
  $<BUILD_INTERFACE:${lager_BINARY_DIR}/>
  $<BUILD_INTERFACE:${lager_SOURCE_DIR}/>
  $<INSTALL_INTERFACE:include>)

if(lager_DISABLE_STORE_DEPENDENCY_CHECKS)
  message(STATUS "Disabling compile-time checks for store dependencies")
  target_compile_definitions(lager INTERFACE LAGER_DISABLE_STORE_DEPENDENCY_CHECKS)
endif()

install(TARGETS lager EXPORT LagerConfig)

# requirements for tests and examples
if (lager_BUILD_TESTS OR lager_BUILD_EXAMPLES)
  find_package(Boost 1.56 COMPONENTS system REQUIRED)
  find_package(Threads REQUIRED)
  find_package(Immer REQUIRED)
  find_package(Zug REQUIRED)
endif()

# the library, local development target
if(lager_BUILD_TESTS)
  add_library(lager-dev INTERFACE)
  target_include_directories(lager-dev SYSTEM INTERFACE
    "$<BUILD_INTERFACE:${lager_SOURCE_DIR}/>/tools/include"
    ${lager_SOURCE_DIR}
    ${Boost_INCLUDE_DIR}
  )
  target_link_libraries(lager-dev INTERFACE lager
    ${Boost_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    immer
    zug
  )
  if (ENABLE_COVERAGE)
    target_compile_options(lager-dev INTERFACE "--coverage")
    target_link_libraries(lager-dev INTERFACE "--coverage")
  endif()
  if (ENABLE_ASAN)
    target_compile_options(lager-dev INTERFACE
      -fno-omit-frame-pointer -fsanitize=address)
    target_link_options(lager-dev INTERFACE -fsanitize=address)
  endif()

  enable_testing()
  add_custom_target(check
    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Build and run all the tests and examples.")

  add_subdirectory(test)
endif()

# the library, with http debugger
if (lager_BUILD_EXAMPLES)

  add_library(lager-example INTERFACE)
  target_include_directories(lager-example INTERFACE
     $<BUILD_INTERFACE:${lager_BINARY_DIR}/>
     $<BUILD_INTERFACE:${lager_SOURCE_DIR}/>
     $<INSTALL_INTERFACE:include>
    ${Boost_INCLUDE_DIR}
  )
  target_link_libraries(lager-example INTERFACE
    lager
    immer
    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
  )

  install(TARGETS lager-example EXPORT LagerConfig)

  # examples with the http debugger
  if (lager_BUILD_DEBUGGER_EXAMPLES)
    add_library(lager-debugger-example INTERFACE)
    target_link_libraries(lager-debugger-example INTERFACE
      lager-example
      Boost::system)

    if (NOT APPLE)
      add_custom_target(gui ALL
        COMMAND make
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/resources/gui"
        COMMENT "Build debugger web UI")
    endif()

    install(TARGETS lager-debugger-example  EXPORT LagerConfig)

    install(FILES
      resources/gui/gui.js
      resources/gui/gui.css
      resources/gui/index.html
      DESTINATION share/lager/gui)
    endif()

  add_subdirectory(example)
endif()

if (lager_BUILD_DOCS)
  add_subdirectory(doc)
endif()

# Also configure and install the resources_path.hpp file if wanted
if (lager_EMBED_RESOURCES_PATH)
  set(LAGER_PREFIX_PATH ${CMAKE_INSTALL_PREFIX})
  configure_file(lager/resources_path.hpp.in
    ${CMAKE_BINARY_DIR}/include/lager/resources_path.hpp)
  target_include_directories(lager
    INTERFACE $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>)
  install(FILES ${CMAKE_BINARY_DIR}/include/lager/resources_path.hpp DESTINATION include/lager)
endif()

install(EXPORT LagerConfig DESTINATION lib/cmake/Lager)
install(DIRECTORY lager DESTINATION include PATTERN "*.hpp")

=== doc/CMakeLists.txt ===

#  Targets
#  =======

add_custom_target(doxygen
  COMMAND doxygen doxygen.config
  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/doc")

add_custom_target(docs
  COMMAND make html
  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/doc")
add_dependencies(docs doxygen)

set(lager_ssh_method
  ssh -p 5488
      -o StrictHostKeyChecking=no)

add_custom_target(upload-docs
  COMMAND
  rsync -av -e \"${lager_ssh_method}\"
        ${CMAKE_SOURCE_DIR}/doc/_build/html/*
        raskolnikov@sinusoid.es:public/lager/)

=== example/CMakeLists.txt ===

add_custom_target(examples COMMENT "Build all examples")
if (lager_BUILD_TESTS)
  add_dependencies(check examples)
endif()

# std  examples
# ====================

add_executable(counter-std EXCLUDE_FROM_ALL
  counter/std/main.cpp)
target_link_libraries(counter-std lager-example)
add_dependencies(examples counter-std)

# ncurses examples
# ================

set(CMAKE_CURSES_NEED_WIDE true)

find_package(Curses)

if(Curses_FOUND)
  if (lager_BUILD_DEBUGGER_EXAMPLES)
    set(counter_ncurses_sources
      counter/ncurses/main.cpp
      counter/ncurses/terminal.cpp)
    set(counter_ncurses_include_directories
      ${CURSES_INCLUDE_DIR})
    set(counter_ncurses_link_libraries
      lager-debugger-example
      ${CURSES_LIBRARIES})

    add_executable(counter-ncurses EXCLUDE_FROM_ALL ${counter_ncurses_sources})
    target_include_directories(counter-ncurses SYSTEM PUBLIC ${counter_ncurses_include_directories})
    target_link_libraries(counter-ncurses ${counter_ncurses_link_libraries})
    target_compile_definitions(counter-ncurses PUBLIC DEBUGGER)
    add_dependencies(examples counter-ncurses)

    add_executable(counter-ncurses-tree EXCLUDE_FROM_ALL ${counter_ncurses_sources})
    target_include_directories(counter-ncurses-tree SYSTEM PUBLIC ${counter_ncurses_include_directories})
    target_link_libraries(counter-ncurses-tree ${counter_ncurses_link_libraries})
    target_compile_definitions(counter-ncurses-tree PUBLIC TREE_DEBUGGER)
    add_dependencies(examples counter-ncurses-tree)

    add_executable(counter-ncurses-meta EXCLUDE_FROM_ALL ${counter_ncurses_sources})
    target_include_directories(counter-ncurses-meta SYSTEM PUBLIC ${counter_ncurses_include_directories})
    target_link_libraries(counter-ncurses-meta ${counter_ncurses_link_libraries})
    target_compile_definitions(counter-ncurses-meta PUBLIC DEBUGGER META_DEBUGGER)
    add_dependencies(examples counter-ncurses-meta)
  endif()
else()
  message(STATUS "Disabling Curses based examples")
endif()

# sdl examples
# ===========

find_package(SDL2)
find_package(SDL2_ttf)

if (SDL2_FOUND AND SDL2_ttf_FOUND)
  if(lager_BUILD_DEBUGGER_EXAMPLES)
    add_executable(counter-sdl2 EXCLUDE_FROM_ALL
      counter/sdl2/main.cpp)
    target_include_directories(counter-sdl2 SYSTEM PUBLIC
      ${SDL2_INCLUDE_DIR}
      ${SDL2_TTF_INCLUDE_DIR})
    target_link_libraries(counter-sdl2
      lager-debugger-example
      ${SDL2_LIBRARY}
      ${SDL2_TTF_LIBRARIES})
    add_dependencies(examples counter-sdl2)

    add_executable(autopong EXCLUDE_FROM_ALL
      autopong/autopong.cpp
      autopong/sdl2/main.cpp)
    target_include_directories(autopong SYSTEM PUBLIC
      ${SDL2_INCLUDE_DIR}
      ${SDL2_TTF_INCLUDE_DIR})
    target_link_libraries(autopong
      lager-debugger-example
      ${SDL2_LIBRARY}
      ${SDL2_TTF_LIBRARIES})
    add_dependencies(examples autopong)

    add_executable(autopong-debug EXCLUDE_FROM_ALL
      autopong/autopong.cpp
      autopong/sdl2/main.cpp)
    target_compile_definitions(autopong-debug PUBLIC DEBUGGER)
    target_include_directories(autopong-debug SYSTEM PUBLIC
      ${SDL2_INCLUDE_DIR}
      ${SDL2_TTF_INCLUDE_DIR})
    target_link_libraries(autopong-debug
      lager-debugger-example
      ${SDL2_LIBRARY}
      ${SDL2_TTF_LIBRARIES})
    add_dependencies(examples autopong-debug)
  endif()
else()
  message(STATUS "Disabling SDL based examples")
endif()

# qt examples
# ===========

find_package(Qt5Core)
find_package(Qt5Concurrent)
find_package(Qt5Qml)
find_package(Qt5Gui)
find_package(Qt5Widgets)
find_package(Qt5QuickControls2)

find_package(Boost 1.56)

if (Qt5Core_FOUND AND Qt5Concurrent_FOUND AND Qt5Gui_FOUND AND Qt5Widgets_FOUND AND Qt5Qml_FOUND AND Qt5QuickControls2_FOUND AND Boost_FOUND)
  add_executable(todo-qml EXCLUDE_FROM_ALL
    todo/item.cpp
    todo/model.cpp
    todo/qml/main.cpp)
  set_target_properties(todo-qml PROPERTIES AUTOMOC YES)
  target_link_libraries(todo-qml lager-example Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
  target_compile_definitions(todo-qml PRIVATE
    LAGER_TODO_QML_DIR="${CMAKE_SOURCE_DIR}/example/todo/qml")
  add_dependencies(examples todo-qml)

  add_executable(todo-qml-redux EXCLUDE_FROM_ALL
    todo/item.cpp
    todo/model.cpp
    todo/app.cpp
    todo/qml-redux/main.cpp)
  set_target_properties(todo-qml-redux PROPERTIES AUTOMOC YES)
  target_link_libraries(todo-qml-redux lager-example Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
  target_compile_definitions(todo-qml-redux PRIVATE
    LAGER_TODO_QML_DIR="${CMAKE_SOURCE_DIR}/example/todo/qml-redux")
  add_dependencies(examples todo-qml-redux)

  add_executable(snake-qml EXCLUDE_FROM_ALL
    snake/model.cpp snake/qml/main.cpp snake/qml/qmodel.cpp)
  set_target_properties(snake-qml PROPERTIES AUTOMOC YES)
  target_link_libraries(snake-qml lager-example Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
  target_include_directories(snake-qml PRIVATE ${Boost_INCLUDE_DIRS})
  target_compile_definitions(snake-qml PRIVATE
    LAGER_SNAKE_QML_DIR="${CMAKE_SOURCE_DIR}/example/snake/qml")
  add_dependencies(examples snake-qml)
else()
  message(STATUS "Disabling Qt based examples")
endif()

# ImGui examples
# ==============

set(OpenGL_GL_PREFERENCE GLVND)
find_package(OpenGL)

set(imgui_source_dir "$ENV{IMGUI_SOURCE_DIR}")

set(imgui_sources
  "${imgui_source_dir}/imgui.cpp"
  "${imgui_source_dir}/imgui_draw.cpp"
  "${imgui_source_dir}/imgui_widgets.cpp"
  "${imgui_source_dir}/imgui_impl_sdl.cpp"
  "${imgui_source_dir}/imgui_impl_opengl3.cpp")

find_program(EMXX em++)

if (EMXX AND OPENGL_FOUND AND SDL2_FOUND AND EXISTS "${imgui_source_dir}/imgui.h")
  message(STATUS "ImGui found in ${imgui_source_dir}")

  set(extra_emcc_flags $ENV{NIX_CFLAGS_COMPILE})
  separate_arguments(extra_emcc_flags)

  add_custom_target(todo-imgui
    COMMAND ${EMXX} ${extra_emcc_flags}
      -Os
      -std=c++17 -I ${CMAKE_SOURCE_DIR}
      -I ${imgui_source_dir}
      ${imgui_sources}
      ${CMAKE_CURRENT_SOURCE_DIR}/todo/item.cpp
      ${CMAKE_CURRENT_SOURCE_DIR}/todo/model.cpp
      ${CMAKE_CURRENT_SOURCE_DIR}/todo/imgui/main.cpp
      -s USE_SDL=2 -s USE_WEBGL2=1 -s WASM=1 -s FULL_ES3=1
      -s ALLOW_MEMORY_GROWTH=1
      --emrun
      --shell-file ${CMAKE_SOURCE_DIR}/resources/emscripten_shell_minimal.html
      -o ${CMAKE_CURRENT_BINARY_DIR}/todo-imgui.html
    COMMENT "Build todo-imgui emscripten example")
  add_dependencies(examples todo-imgui)
else()
  message(STATUS "Disabling ImGui based examples")
endif()

=== test/CMakeLists.txt ===

#  Utils
#  =====

find_package(Qt5Core)
find_package(Qt5Concurrent)
find_package(Qt5Qml)
find_package(Qt5Quick)

function(lager_target_name_for out_target out_file file)
  get_filename_component(_extension ${_file} EXT)

  file(RELATIVE_PATH _relative ${PROJECT_SOURCE_DIR} ${file})
  string(REPLACE "${_extension}" "" _name ${_relative})
  string(REGEX REPLACE "/" "-" _name ${_name})
  set(${out_target} "${_name}" PARENT_SCOPE)

  string(REPLACE "${_extension}" "" _name ${_relative})
  string(REGEX REPLACE "/" "-" _name ${_name})
  set(${out_file} "${_name}" PARENT_SCOPE)
endfunction()

function(lager_get_qt_libs out_qt_required out_qt_libs target)
  set(${out_qt_required} FALSE PARENT_SCOPE)
  unset(${out_qt_libs} PARENT_SCOPE)

  string(FIND ${target} "qt" _qt_required)
  if(${_qt_required} GREATER 0)
    set(${out_qt_required} TRUE PARENT_SCOPE)
    if(${Qt5Core_FOUND} AND ${Qt5Concurrent_FOUND})
      set(${out_qt_libs} PRIVATE Qt5::Core Qt5::Concurrent PARENT_SCOPE)
    endif()
  endif()

  string(FIND ${target} "qml" _qml_required)
  if(${_qml_required} GREATER 0)
    set(${out_required} TRUE PARENT_SCOPE)
    if(${Qt5Core_FOUND} AND ${Qt5Quick_FOUND})
      set(${out_qt_libs} PRIVATE Qt5::Core Qt5::Quick PARENT_SCOPE)
    endif()
  endif()
endfunction()

#  Targets
#  =======

find_package(Qt5 COMPONENTS Core Concurrent)

add_custom_target(tests COMMENT "Build all the unit tests.")
add_dependencies(check tests)

file(GLOB lager_unit_tests "*.cpp" "cereal/*.cpp" "event_loop/*.cpp" "extra/*.cpp")

foreach(_file IN LISTS lager_unit_tests)
  message("found unit test: " ${_file})
  lager_target_name_for(_target _output "${_file}")
  lager_get_qt_libs(_qt_required _qt_libs ${_target})
  if(${_qt_required} AND (NOT DEFINED _qt_libs))
    message(WARNING "Qt dependency not found - skipping target ${_target}")
    continue()
  endif()
  add_executable(${_target} EXCLUDE_FROM_ALL "${_file}")
  set_target_properties(${_target} PROPERTIES OUTPUT_NAME ${_output})
  add_dependencies(tests ${_target})
  target_compile_definitions(${_target} PUBLIC CATCH_CONFIG_MAIN)
  target_link_libraries(${_target} PUBLIC lager-dev ${_qt_libs})
  add_test("test/${_output}" ${_output})
endforeach()


if (lager_BUILD_FAILURE_TESTS)
  add_subdirectory(build_failure)
endif()

=== debian/changelog ===
lager (0.1.0-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 05 Oct 2023 13:24:16 -0700

lager (0.1.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Ship the examples in liblager-dev.
  * Add libboost-dev, libimmer-dev, and libzug-dev as dependencies of
    liblager-dev.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Aug 2023 11:28:06 +0200

lager (0.1.0-1) experimental; urgency=medium

  * Initial packaging.

 -- Pino Toscano <pino@debian.org>  Fri, 28 Jul 2023 22:00:53 +0200

=== debian/control ===
Source: lager
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: cmake (>= 3.8~),
               debhelper-compat (= 13),
               libboost-dev (>= 1.56~),
               libboost-system-dev (>= 1.56~),
               libcereal-dev <!nocheck>,
               libimmer-dev,
               libzug-dev,
               qtbase5-dev,
               qtdeclarative5-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/arximboldi/lager
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/lager
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/lager.git

Package: liblager-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libboost-dev, libimmer-dev, libzug-dev, ${misc:Depends}
Description: C++ library for value-oriented design-- development files
 lager is a C++ library to assist value-oriented design by implementing the
 unidirectional data-flow architecture. It is heavily inspired by Elm and Redux,
 and enables composable designs by promoting the use of simple value types and
 testable application logic via pure functions. And you get time-travel for
 free!
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

# https://github.com/arximboldi/immer/issues/223
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-array-bounds

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	  -Dlager_BUILD_EXAMPLES=OFF \
	  -Dlager_BUILD_DEBUGGER_EXAMPLES=OFF \
	  -Dlager_BUILD_DOCS=OFF

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	dh_auto_build -- tests
endif

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## lager 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,8 @@
 if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
 endif()
+
+include(GNUInstallDirs)
 
 option(lager_BUILD_TESTS "Build tests" ON)
 option(lager_BUILD_FAILURE_TESTS "Build failure tests" ON)
@@ -58,7 +60,7 @@
 target_include_directories(lager INTERFACE
   $<BUILD_INTERFACE:${lager_BINARY_DIR}/>
   $<BUILD_INTERFACE:${lager_SOURCE_DIR}/>
-  $<INSTALL_INTERFACE:include>)
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
 
 if(lager_DISABLE_STORE_DEPENDENCY_CHECKS)
   message(STATUS "Disabling compile-time checks for store dependencies")
@@ -77,9 +79,10 @@
 
 # the library, local development target
 if(lager_BUILD_TESTS)
+  find_package(Catch2 REQUIRED)
+
   add_library(lager-dev INTERFACE)
   target_include_directories(lager-dev SYSTEM INTERFACE
-    "$<BUILD_INTERFACE:${lager_SOURCE_DIR}/>/tools/include"
     ${lager_SOURCE_DIR}
     ${Boost_INCLUDE_DIR}
   )
@@ -147,7 +150,7 @@
       resources/gui/gui.js
       resources/gui/gui.css
       resources/gui/index.html
-      DESTINATION share/lager/gui)
+      DESTINATION "${CMAKE_INSTALL_DATADIR}/lager/gui")
     endif()
 
   add_subdirectory(example)
@@ -164,8 +167,8 @@
     ${CMAKE_BINARY_DIR}/include/lager/resources_path.hpp)
   target_include_directories(lager
     INTERFACE $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>)
-  install(FILES ${CMAKE_BINARY_DIR}/include/lager/resources_path.hpp DESTINATION include/lager)
+  install(FILES ${CMAKE_BINARY_DIR}/include/lager/resources_path.hpp DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/lager")
 endif()
 
-install(EXPORT LagerConfig DESTINATION lib/cmake/Lager)
-install(DIRECTORY lager DESTINATION include PATTERN "*.hpp")
+install(EXPORT LagerConfig DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/Lager")
+install(DIRECTORY lager DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}" PATTERN "*.hpp")

=== doc/CMakeLists.txt ===

#  Targets
#  =======

add_custom_target(doxygen
  COMMAND doxygen doxygen.config
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

add_custom_target(docs
  COMMAND make html
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
add_dependencies(docs doxygen)

set(lager_ssh_method
  ssh -p 5488
      -o StrictHostKeyChecking=no)

add_custom_target(upload-docs
  COMMAND
  rsync -av -e \"${lager_ssh_method}\"
        ${CMAKE_CURRENT_SOURCE_DIR}/_build/html/*
        raskolnikov@sinusoid.es:public/lager/)

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  epub3      to make an epub3"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"
	@echo "  dummy      to check syntax errors of document sources"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	bash sphinx-html-hack.bash
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/lager.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/lager.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/lager"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/lager"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: epub3
epub3:
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

.PHONY: dummy
dummy:
	$(SPHINXBUILD) -b dummy $(ALLSPHINXOPTS) $(BUILDDIR)/dummy
	@echo
	@echo "Build finished. Dummy builder generates no files."

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # ncurses examples
 # ================
 
-set(CMAKE_CURSES_NEED_WIDE true)
+set(CURSES_NEED_WIDE true)
 
 find_package(Curses)
 
@@ -63,11 +63,11 @@
     add_executable(counter-sdl2 EXCLUDE_FROM_ALL
       counter/sdl2/main.cpp)
     target_include_directories(counter-sdl2 SYSTEM PUBLIC
-      ${SDL2_INCLUDE_DIR}
+      ${SDL2_INCLUDE_DIRS}
       ${SDL2_TTF_INCLUDE_DIR})
     target_link_libraries(counter-sdl2
       lager-debugger-example
-      ${SDL2_LIBRARY}
+      ${SDL2_LIBRARIES}
       ${SDL2_TTF_LIBRARIES})
     add_dependencies(examples counter-sdl2)
 
@@ -75,11 +75,11 @@
       autopong/autopong.cpp
       autopong/sdl2/main.cpp)
     target_include_directories(autopong SYSTEM PUBLIC
-      ${SDL2_INCLUDE_DIR}
+      ${SDL2_INCLUDE_DIRS}
       ${SDL2_TTF_INCLUDE_DIR})
     target_link_libraries(autopong
       lager-debugger-example
-      ${SDL2_LIBRARY}
+      ${SDL2_LIBRARIES}
       ${SDL2_TTF_LIBRARIES})
     add_dependencies(examples autopong)
 
@@ -88,11 +88,11 @@
       autopong/sdl2/main.cpp)
     target_compile_definitions(autopong-debug PUBLIC DEBUGGER)
     target_include_directories(autopong-debug SYSTEM PUBLIC
-      ${SDL2_INCLUDE_DIR}
+      ${SDL2_INCLUDE_DIRS}
       ${SDL2_TTF_INCLUDE_DIR})
     target_link_libraries(autopong-debug
       lager-debugger-example
-      ${SDL2_LIBRARY}
+      ${SDL2_LIBRARIES}
       ${SDL2_TTF_LIBRARIES})
     add_dependencies(examples autopong-debug)
   endif()
@@ -120,7 +120,7 @@
   set_target_properties(todo-qml PROPERTIES AUTOMOC YES)
   target_link_libraries(todo-qml lager-example Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
   target_compile_definitions(todo-qml PRIVATE
-    LAGER_TODO_QML_DIR="${CMAKE_SOURCE_DIR}/example/todo/qml")
+    LAGER_TODO_QML_DIR="${CMAKE_CURRENT_SOURCE_DIR}/todo/qml")
   add_dependencies(examples todo-qml)
 
   add_executable(todo-qml-redux EXCLUDE_FROM_ALL
@@ -131,7 +131,7 @@
   set_target_properties(todo-qml-redux PROPERTIES AUTOMOC YES)
   target_link_libraries(todo-qml-redux lager-example Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
   target_compile_definitions(todo-qml-redux PRIVATE
-    LAGER_TODO_QML_DIR="${CMAKE_SOURCE_DIR}/example/todo/qml-redux")
+    LAGER_TODO_QML_DIR="${CMAKE_CURRENT_SOURCE_DIR}/todo/qml-redux")
   add_dependencies(examples todo-qml-redux)
 
   add_executable(snake-qml EXCLUDE_FROM_ALL
@@ -140,7 +140,7 @@
   target_link_libraries(snake-qml lager-example Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets Qt5::Qml Qt5::QuickControls2)
   target_include_directories(snake-qml PRIVATE ${Boost_INCLUDE_DIRS})
   target_compile_definitions(snake-qml PRIVATE
-    LAGER_SNAKE_QML_DIR="${CMAKE_SOURCE_DIR}/example/snake/qml")
+    LAGER_SNAKE_QML_DIR="${CMAKE_CURRENT_SOURCE_DIR}/snake/qml")
   add_dependencies(examples snake-qml)
 else()
   message(STATUS "Disabling Qt based examples")

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,7 @@
 add_custom_target(tests COMMENT "Build all the unit tests.")
 add_dependencies(check tests)
 
-file(GLOB lager_unit_tests "*.cpp" "cereal/*.cpp" "event_loop/*.cpp" "extra/*.cpp")
+file(GLOB lager_unit_tests "*.cpp" "cereal/*.cpp" "event_loop/*.cpp" "extra/*.cpp" "detail/*.cpp")
 
 foreach(_file IN LISTS lager_unit_tests)
   message("found unit test: " ${_file})
@@ -63,7 +63,7 @@
   set_target_properties(${_target} PROPERTIES OUTPUT_NAME ${_output})
   add_dependencies(tests ${_target})
   target_compile_definitions(${_target} PUBLIC CATCH_CONFIG_MAIN)
-  target_link_libraries(${_target} PUBLIC lager-dev ${_qt_libs})
+  target_link_libraries(${_target} PUBLIC lager-dev Catch2::Catch2 ${_qt_libs})
   add_test("test/${_output}" ${_output})
 endforeach()

=== test/build_failure/CMakeLists.txt ===
include(icm_build_failure_testing)

set(_glob_pattern "*.cpp")

file(GLOB_RECURSE lager_build_failure_tests ${_glob_pattern})
foreach(_file IN LISTS lager_build_failure_tests)
  message("found build failure test: " ${_file})
endforeach()

# We test that the build fails and the failure message
# contains the offending line.
#
# see: https://ibob.bg/blog/2022/10/04/testing-build-failure-with-cmake/
icm_glob_build_failure_tests(
  PATTERN ${_glob_pattern}
  LIBRARIES lager-dev
  PREFIX "build-failure"
  ERROR_MATCHES "offending line"
)

=== debian/changelog ===
lager (0.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Include-cstdint-for-std-uint32_t.patch: drop, backported from
      upstream
    - upstream_Fix-build-of-http_debug_server-with-boost-1.80.patch: drop,
      backported from upstream
  * Update the build dependencies according to the upstream build system:
    - add catch2
  * Update copyright.
  * Disable the tests for now: they assume Catch2 v2.x, and v3 requires changes.
  * Drop the manual search for ncurses and SDL2 in the 'build-examples'
    autopkgtest: the upstream CMakeLists.txt was fixed to properly search and
    use them.

 -- Pino Toscano <pino@debian.org>  Sun, 15 Oct 2023 21:17:09 +0200

lager (0.1.0-4) unstable; urgency=medium

  * Backport upstream commit ed62d99a1ed774f2b5a336684ee58e64e7c1f5c4 to support
    boost >= 1.80; patch
    upstream_Fix-build-of-http_debug_server-with-boost-1.80.patch.
  * Fix typo in the short description.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Oct 2023 08:37:53 +0200

lager (0.1.0-3) unstable; urgency=medium

  * Backport upstream commit 073c03acfdaf39f24ba2cd642743320979d53b6d to add
    a missing include in the SDL event loop; patch
    upstream_Include-cstdint-for-std-uint32_t.patch.
  * Add a 'build-examples' autopkgtest to build almost all the examples:
    ncurses, SDL2, Qt5.
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Wed, 04 Oct 2023 21:03:35 +0200

=== debian/rules ===
#!/usr/bin/make -f

# https://github.com/arximboldi/immer/issues/223
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-array-bounds

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	  -Dlager_BUILD_TESTS=OFF \
	  -Dlager_BUILD_EXAMPLES=OFF \
	  -Dlager_BUILD_DEBUGGER_EXAMPLES=OFF \
	  -Dlager_BUILD_DOCS=OFF

ifeq (disabledfornow,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	dh_auto_build -- tests
endif

=== debian/tests/control ===
Tests: build-examples
Depends: build-essential, cmake, liblager-dev, libcereal-dev, libboost-dev, qtbase5-dev, qtdeclarative5-dev, qtquickcontrols2-5-dev, libncurses-dev, libsdl2-dev, libsdl2-ttf-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/arximboldi/lager/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## lager 0.1.2

=== debian/changelog ===
lager (0.1.2-2) unstable; urgency=medium

  * Stop using Boost::system: (Closes: #1127219)
    - backport upstream commit 0eb1d3d3a6057723c5b57b3e0ee3e41924ff419a;
      patch upstream_Stop-using-Boost-system.patch
    - drop the libboost-system-dev build dependency

 -- Pino Toscano <pino@debian.org>  Fri, 13 Feb 2026 05:01:21 +0100

lager (0.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.10
  * Update the patches:
    - Switch-from-boost-asio-io_service-to-io_context.diff: drop, fixed upstream

 -- Pino Toscano <pino@debian.org>  Tue, 20 Jan 2026 06:40:30 +0100

lager (0.1.1-3) unstable; urgency=medium

  * Backport the upstream PR https://github.com/arximboldi/lager/pull/227 to
    switch from boost::asio::io_service to io_context, as the former is a long
    deprecated alias, removed in newer versions of boost. (Closes: #1110833)

 -- Pino Toscano <pino@debian.org>  Sun, 21 Dec 2025 09:44:45 +0100

lager (0.1.1-2) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Disable the build of the debugger examples in the 'build-examples'
    autopkgtest: counter-ncurses-tree fails to build with immer 0.9.0:
    https://github.com/arximboldi/lager/issues/228

 -- Pino Toscano <pino@debian.org>  Mon, 15 Dec 2025 22:39:58 +0100

=== debian/control ===
Source: lager
Section: libs
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: catch2,
               cmake (>= 3.10~),
               debhelper-compat (= 13),
               libboost-dev (>= 1.56~),
               libcereal-dev <!nocheck>,
               libimmer-dev,
               libzug-dev,
               qtbase5-dev,
               qtdeclarative5-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/arximboldi/lager
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/lager
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/lager.git

Package: liblager-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libboost-dev,
         libimmer-dev,
         libzug-dev,
Description: C++ library for value-oriented design -- development files
 lager is a C++ library to assist value-oriented design by implementing the
 unidirectional data-flow architecture. It is heavily inspired by Elm and Redux,
 and enables composable designs by promoting the use of simple value types and
 testable application logic via pure functions. And you get time-travel for
 free!
 .
 This package contains the development files.

## lager 0.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.8)
+cmake_minimum_required(VERSION 3.21)
 cmake_policy(SET CMP0048 NEW) # enable project VERSION
 cmake_policy(SET CMP0056 NEW) # honor link flags in try_compile()
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
@@ -21,13 +21,19 @@
 
 include(GNUInstallDirs)
 
-option(lager_BUILD_TESTS "Build tests" ON)
-option(lager_BUILD_FAILURE_TESTS "Build failure tests" ON)
-option(lager_BUILD_EXAMPLES "Build examples" ON)
-option(lager_BUILD_DEBUGGER_EXAMPLES "Build examples that showcase the web based debugger" ON)
-option(lager_BUILD_DOCS "Build docs" ON)
+option(lager_BUILD_TESTS "Build tests" "${PROJECT_IS_TOP_LEVEL}")
+option(lager_BUILD_FAILURE_TESTS "Build failure tests" "${PROJECT_IS_TOP_LEVEL}")
+option(lager_BUILD_EXAMPLES "Build examples" "${PROJECT_IS_TOP_LEVEL}")
+option(lager_BUILD_DEBUGGER_EXAMPLES "Build examples that showcase the web based debugger" "${PROJECT_IS_TOP_LEVEL}")
+option(lager_BUILD_DOCS "Build docs" "${PROJECT_IS_TOP_LEVEL}")
 option(lager_EMBED_RESOURCES_PATH "Embed installation paths for easier, non-portable resource location" ON)
 option(lager_DISABLE_STORE_DEPENDENCY_CHECKS "Disable compile-time checks for store dependencies" OFF)
+option(lager_ENABLE_EXCEPTIONS "Always enable exceptions regardless of detected compiler support" OFF)
+option(lager_DISABLE_EXCEPTIONS "Always disable exceptions regardless of detected compiler support" OFF)
+
+if (lager_ENABLE_EXCEPTIONS AND lager_DISABLE_EXCEPTIONS)
+  message(FATAL_ERROR "Cannot both enable and disable exceptions")
+endif()
 
 if (NOT lager_EMBED_RESOURCES_PATH AND lager_BUILD_EXAMPLES)
   message(FATAL_ERROR "Examples require embedded resources path")
@@ -46,8 +52,8 @@
 find_program(CCACHE ccache)
 if (CCACHE)
   message(STATUS "Using ccache: ${CCACHE}")
-  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE})
-  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE})
+  set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
+  set(CMAKE_CXX_LINK_LAUNCHER ${CCACHE})
 else()
   message(STATUS "Could not find ccache")
 endif()
@@ -57,6 +63,7 @@
 
 # the library
 add_library(lager INTERFACE)
+add_library(lager::lager ALIAS lager)
 target_include_directories(lager INTERFACE
   $<BUILD_INTERFACE:${lager_BINARY_DIR}/>
   $<BUILD_INTERFACE:${lager_SOURCE_DIR}/>
@@ -67,11 +74,95 @@
   target_compile_definitions(lager INTERFACE LAGER_DISABLE_STORE_DEPENDENCY_CHECKS)
 endif()
 
-install(TARGETS lager EXPORT LagerConfig)
+if(lager_ENABLE_EXCEPTIONS)
+  message(STATUS "Explicitly enabling exceptions")
+  target_compile_definitions(lager INTERFACE LAGER_USE_EXCEPTIONS)
+endif()
+
+if(lager_DISABLE_EXCEPTIONS)
+  message(STATUS "Explicitly disabling exceptions")
+  target_compile_definitions(lager INTERFACE LAGER_NO_EXCEPTIONS)
+endif()
+
+target_sources(lager PUBLIC FILE_SET HEADERS
+  FILES
+    lager/commit.hpp
+    lager/config.hpp
+    lager/constant.hpp
+    lager/context.hpp
+    lager/cursor.hpp
+    lager/debug/debugger.hpp
+    lager/debug/http_server.hpp
+    lager/debug/tree_debugger.hpp
+    lager/deps.hpp
+    lager/detail/access.hpp
+    lager/detail/lens_nodes.hpp
+    lager/detail/merge_nodes.hpp
+    lager/detail/no_value.hpp
+    lager/detail/nodes.hpp
+    lager/detail/signal.hpp
+    lager/detail/smart_lens.hpp
+    lager/detail/xform_nodes.hpp
+    lager/effect.hpp
+    lager/event_loop/boost_asio.hpp
+    lager/event_loop/manual.hpp
+    lager/event_loop/qml.hpp
+    lager/event_loop/qt.hpp
+    lager/event_loop/queue.hpp
+    lager/event_loop/safe_queue.hpp
+    lager/event_loop/sdl.hpp
+    lager/extra/cereal/enum.hpp
+    lager/extra/cereal/immer_array.hpp
+    lager/extra/cereal/immer_box.hpp
+    lager/extra/cereal/immer_flex_vector.hpp
+    lager/extra/cereal/immer_map.hpp
+    lager/extra/cereal/immer_set.hpp
+    lager/extra/cereal/immer_table.hpp
+    lager/extra/cereal/immer_vector.hpp
+    lager/extra/cereal/inline.hpp
+    lager/extra/cereal/json.hpp
+    lager/extra/cereal/optional_nvp.hpp
+    lager/extra/cereal/struct.hpp
+    lager/extra/cereal/tuple.hpp
+    lager/extra/cereal/variant_with_name.hpp
+    lager/extra/derive.hpp
+    lager/extra/derive/cereal.hpp
+    lager/extra/derive/eq.hpp
+    lager/extra/derive/hana.hpp
+    lager/extra/derive/hash.hpp
+    lager/extra/derive/size_check.hpp
+    lager/extra/enum.hpp
+    lager/extra/qt.hpp
+    lager/extra/struct.hpp
+    lager/extra/thunk.hpp
+    lager/future.hpp
+    lager/lens.hpp
+    lager/lenses.hpp
+    lager/lenses/at.hpp
+    lager/lenses/at_or.hpp
+    lager/lenses/attr.hpp
+    lager/lenses/optional.hpp
+    lager/lenses/tuple.hpp
+    lager/lenses/unbox.hpp
+    lager/lenses/variant.hpp
+    lager/reader.hpp
+    lager/resources_path.hpp.in
+    lager/sensor.hpp
+    lager/setter.hpp
+    lager/state.hpp
+    lager/store.hpp
+    lager/tags.hpp
+    lager/util.hpp
+    lager/watch.hpp
+    lager/with.hpp
+    lager/writer.hpp
+)
+
+install(TARGETS lager EXPORT LagerConfig FILE_SET HEADERS)
 
 # requirements for tests and examples
 if (lager_BUILD_TESTS OR lager_BUILD_EXAMPLES)
-  find_package(Boost 1.56 COMPONENTS system REQUIRED)
+  find_package(Boost 1.56 CONFIG)
   find_package(Threads REQUIRED)
   find_package(Immer REQUIRED)
   find_package(Zug REQUIRED)
@@ -134,15 +225,12 @@
   if (lager_BUILD_DEBUGGER_EXAMPLES)
     add_library(lager-debugger-example INTERFACE)
     target_link_libraries(lager-debugger-example INTERFACE
-      lager-example
-      Boost::system)
-
-    if (NOT APPLE)
-      add_custom_target(gui ALL
-        COMMAND make
-        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/resources/gui"
-        COMMENT "Build debugger web UI")
-    endif()
+      lager-example)
+
+    add_custom_target(gui ALL
+      COMMAND make
+      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/resources/gui"
+      COMMENT "Build debugger web UI")
 
     install(TARGETS lager-debugger-example  EXPORT LagerConfig)

=== debian/changelog ===
lager (0.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Stop-using-Boost-system.patch: drop, backported from upstream

 -- Pino Toscano <pino@debian.org>  Thu, 26 Feb 2026 20:11:17 +0100
